/**
 * Program: UDapplet.java
 * Comments: Wrapper for an applet that supports uploading and downloading 
 * of both files and directories.  This particular program is kept simple
 * so that the components can be placed in an application.
 */

import java.awt.*;
import javax.swing.*;
import WebFlow.*;
import org.omg.CORBA.*;
import WebFlow.RemoteFile.*;
import WebFlow.FB.*;
import netscape.security.*;

public class UDapplet extends JApplet {

    PrivilegeManager privMgr;
    netscape.security.Principal myPrincipal;
    
    UDPanel basePanel;
    String urlfile="http://dev-spt01:8080/GOW/IOR/master.txt";
    String masterIOR;
    public ORB orb;
    public WebFlowContext master=null;
    org.omg.CORBA.Object obj;
    RemoteFile rf;
    FBServer fb; 
    JTree tree;
    String root;
    RemoteTree remoteTree;
    LocalTree localTree;
    FileTransferBean ftb;


    public void init() {
	
	//Set up some Netscape security stuff
	myPrincipal=PrivilegeManager.getMyPrincipals()[0];
	privMgr=PrivilegeManager.getPrivilegeManager();
		
	//Connect to the master
	masterIOR=WebFlow.ClientUtils.getIORFromURL(urlfile);
	orb=WebFlow.ClientUtils.initAppletORB(this);
	master=WebFlow.ClientUtils.getMasterServer(masterIOR,orb);

	//Instatiate some webflow objects
	obj=WebFlow.ClientUtils.makeModule(master,"RemoteFile");
	rf=RemoteFileHelper.narrow(obj);
	rf.test();

	obj=WebFlow.ClientUtils.makeModule(master,"FileBrowser");
	fb=FBServerHelper.narrow(obj);
	fb.test();

	//Set up tree objects.
	localTree=new LocalTree();
	remoteTree=new RemoteTree(rf,fb);
	
	//Initialize the FileTransferBean object
	ftb=new FileTransferBean(rf);

	//Setup gui 
	basePanel=new UDPanel(this);
	java.awt.Container contentPane=getContentPane();
	contentPane.add(basePanel);
    }

    /**
     * A couple of getter methods for other classes (such as UDPanel) to
     * retrieve UDapplets security objects.
     */
    public PrivilegeManager getPrivMan() { return privMgr; }
    public netscape.security.Principal getMyPrincipal(){ return myPrincipal; }

    /**
     * The following are getter methods for the applet's modules
     */
    public RemoteFile getRemoteFileObj(){ return rf; }
    public FBServer getFBServerObj() { return fb; }

    /**
     * The following are getters for the remote and local tree objects.
     */
    public RemoteTree getRemoteTree(){ return remoteTree;}
    public LocalTree getLocalTree() { return localTree;}

    /**
     * This is a getter for the FileTransferBean object.
     */
    public FileTransferBean getFileTransferBean() {return ftb;}
    
}





